#include <streamer/streamer.h>
#include <sink.h>
#include "common.h"

StreamElementType *_sink;

StreamElement *Stream_sink_create() {
  Stream_sink *element;

  element = (Stream_sink *)malloc(sizeof(Stream_sink));

  element->element.flags = 0;
  element->element.inpadfunc = NULL; /* lave it up to the general case */
  element->element.outpadfunc = NULL; /* ditto */
  element->element.chain = Stream_sink_chain;
  element->element.push = NULL;
  element->element.inpads = NULL;
  element->element.outpads = NULL;

  /* construct the input pad */
  element->in.type = 0;
  element->in.flags = 0;
  element->in.owner = (StreamElement *)element;
  element->in.peer = NULL;
  element->in.chain = Stream_sink_chain;
  DEBUG("sink set chain to %p\n",element->in.chain);
  /* register it */
  element->element.inpads =
    g_slist_append(element->element.inpads,&element->in);

  return (StreamElement *)element;
}

void Stream_sink_chain(StreamPad *pad,StreamBuffer *buf) {
  Stream_sink *sink_element = (Stream_sink *)pad->owner;
  DEBUG("Stream_sink_chain: got buffer, contents %s\n",buf->data);
  StreamBuffer_free(buf);
}


void init_StreamPlugin(StreamPlugin *plugin) {
  /* we have to do this because we're going to return static data */
  g_module_make_resident(plugin->module);

  /* fill in the StreamPlugin data */
  plugin->name = "sink";
  plugin->longname = "Sink";
  plugin->version = "0.0.0";
  plugin->elementtypes = NULL;
  plugin->enumtypes = NULL; /* simple case, we rely on default */

  /* now create the element type */
  _sink = (StreamElementType *)g_malloc(sizeof(StreamElementType));
  _sink->plugin = plugin;
  _sink->name = "sink";
  _sink->longname = "Sink";
  _sink->version = "0.0.0";
  _sink->create = Stream_sink_create;

  /* add it to the necessary lists */
  plugin->elementtypes = g_slist_append(plugin->elementtypes,_sink);
  StreamElementType_register(_sink);

  /* announce that we're here... */
  DEBUG("initialized plugin '%s'\n",StreamPlugin_getname(plugin));
}
