#include <stdio.h>
#include <streamer.h>
#include <zero.h>

StreamElement *Stream_zero_create() {
  Stream_zero *element;

  element = (Stream_zero *)malloc(sizeof(Stream_zero));

  element->element.flags = 0;
  element->element.inpad = Stream_zero_inpad;
  element->element.outpad = Stream_zero_outpad;
  element->element.chain = Stream_zero_chain;
  element->element.push = NULL;

  element->in.type = 0;
  element->in.flags = 0;
  element->in.owner = (StreamElement *)element;
  element->in.peer = NULL;
  element->in.chain = Stream_zero_chain;
  g_print("zero set chain to %p\n",element->in.chain);

  element->out.type = 0;
  element->out.flags = 0;
  element->out.owner = (StreamElement *)element;
  element->out.peer = NULL;
  element->out.chain = NULL;

  return (StreamElement *)element;
}

StreamPad *Stream_zero_inpad(StreamElement *element,int idx) {
  Stream_zero *zero_element = (Stream_zero *)element;
  return &zero_element->in;
}

StreamPad *Stream_zero_outpad(StreamElement *element,int idx) {
  Stream_zero *zero_element = (Stream_zero *)element;
  return &zero_element->out;
}

void Stream_zero_chain(StreamPad *pad,StreamBuffer *buf) {
  Stream_zero *zero_element = (Stream_zero *)pad->owner;
  if (zero_element->out.chain) {
    g_print("zero just cleared buffer %p\n",buf);
    memset(buf->data,0,buf->datasize);
    g_print("zero about to chain buffer %p to %p()\n",buf,
            zero_element->out.chain);
    (zero_element->out.chain)(zero_element->out.peer,buf);
  }
}
