# Note that this is NOT a relocatable package
%define name	gnome-streamer
%define ver	0.0.1
%define rel	SNAP
%define prefix	/usr

Summary: Streaming-media framework for GNOME
Name: %name
Version: %ver
Release: %rel
Copyright: LGPL
Group: X11/Libraries
Source: %{name}-%{ver}.tar.gz
BuildRoot: /var/tmp/%{name}-%{ver}-root
Docdir: %{prefix}/doc
Prefix: %prefix
Requires: glib

%description
Gnome-streamer provides a framework for various kinds of streaming media,
primarily audio and video.  Plugins are provided for mp3, mpeg-1, and
others.

%package devel
Summary: Libraries and include files for developing gnome-streamer apps.
Group: X11/Libraries
Requires: gnome-streamer

%description devel
Libraries and include files for developing gnome-streamer apps.

%package demos
Summary: Demo applications for gnome-streamer
Group: X11/Applications
Requires: gnome-streamer

%description demos
Demos for gnome-streamer including a generic multi-format video player.

%changelog
* Thu May 13 1999 Erik Walthinsen <omega@cse.ogi.edu>
- first version of spec file

%prep
%setup

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%prefix

if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{prefix} install

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)

%doc AUTHORS COPYING ChangeLog NEWS README
%{prefix}/lib/lib*.so.*
%{prefix}/lib/streamer/lib*.so
%{prefix}/lib/streamer/lib*.so.*

%files devel
%defattr(-, root, root)

%{prefix}/lib/lib*.so
%{prefix}/lib/lib*a
%{prefix}/lib/streamer/lib*a
%{prefix}/include/*

%file demos
%defattr(-, root, root)

%{prefix}/bin/*
