#include <dbug.h>
#include <player/render.h>
#include <gtk-gui/gui.h>
#include <pthread.h>

GtkWidget *
gui_render_new(guchar *title, gint width, gint height)
{
  //GtkWidget *frame, *vbox, *drawing_area;
  GtkWidget *hbox, *vbox, *drawing_area;
  DBUG_ENTER();
  gui_threads_enter();
  hbox = gtk_hbox_new(FALSE,0);
  vbox = gtk_vbox_new(FALSE,0);
  //frame = gtk_frame_new(title);
  //gtk_frame_set_shadow_type(GTK_FRAME(frame),   GTK_SHADOW_ETCHED_OUT);
  drawing_area = gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA(drawing_area), width, height);
  //gtk_container_add(GTK_CONTAINER(frame), drawing_area);
  gtk_box_pack_start(GTK_BOX(hbox), drawing_area, TRUE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 0);
  gtk_object_set_data(GTK_OBJECT(vbox), "_DrawingArea", (gpointer)drawing_area);
  gui_threads_leave();
  DBUG_RETURN(vbox);
} // gui_render_init

GdkImage *
gui_render_image_new(GtkWidget *render)
{
  GtkWidget *drawing_area;
  GdkImage *image;
  DBUG_ENTER();
  g_return_val_if_fail(NULL != render,NULL);
  gui_threads_enter();
  drawing_area = (GtkWidget *)gtk_object_get_data(GTK_OBJECT(render), "_DrawingArea");
  image = gdk_image_new(GDK_IMAGE_FASTEST, 
			gtk_widget_get_visual(render),
			drawing_area->requisition.width,
			drawing_area->requisition.height);
  gui_threads_leave();
  DBUG_RETURN(image);
} // gui_render_image_new

void
gui_render_display_image(GtkWidget *render, GdkImage *image)
{
  GtkWidget *drawing_area;
  DBUG_ENTER();
  gui_threads_enter();
  drawing_area = (GtkWidget *)gtk_object_get_data(GTK_OBJECT(render), "_DrawingArea");
  gdk_draw_image(drawing_area->window, 
		 drawing_area->style->fg_gc[GTK_WIDGET_STATE(drawing_area)],
		 image,
		 0,0,0,0,image->width,image->height);
  gdk_flush();
  gui_threads_leave();
  DBUG_VOID_RETURN();
} // gui_render_display_image

GdkVisual *
gui_render_get_visual(GtkWidget *render)
{
  GtkWidget *drawing_area;
  GdkVisual *result;
  DBUG_ENTER();
  gui_threads_enter();
  drawing_area = (GtkWidget *)gtk_object_get_data(GTK_OBJECT(render), "_DrawingArea");
  result = gtk_widget_get_visual(drawing_area);
  gui_threads_leave();
  DBUG_RETURN(result);
} // gui_render_get_visual
