#ifndef STREAMER_BUFFER_H
#define STREAMER_BUFFER_H

#include <streamer/streamer.h>

struct _StreamBuffer {
  GMutex *mutex;

  /* pointer to the pool and chunk this buffer comes from */
  StreamBufferPool *pool;
  GMemChunk *poolchunk;

  /* usage info */
  gint refcount;


  /* basic type information (FIXME: this is probably lame) */
  glong type; 
  glong flags;

  /* typemeta size and pointer */
  glong typemetasize;
  gpointer typemeta;

  /* metadata size and pointer */  
  glong metasize;
  gpointer meta;

  /* real data size and pointer */
  glong datasize;
  glong dataused;
  gpointer data;

  /* couple of utility functions */
  StreamBuffer *(*copyfunc)(StreamBuffer *);
  gboolean (*freefunc)(StreamBuffer *);
};


void _StreamBuffer_init();

void StreamBuffer_init(StreamBuffer *buf);
StreamBuffer *StreamBuffer_create(StreamBufferPool *pool);
void StreamBuffer_free(StreamBuffer *buf);

gboolean StreamBuffer_nullfree(StreamBuffer *buf);

#endif /* STREAMER_BUFFER_H */
