#ifndef STREAMER_BUFFERPOOL_H
#define STREAMER_BUFFERPOOL_H

#include <streamer/streamer.h>

struct _StreamBufferPool {
  GMutex *mutex;

  /* total buffers in pool */
  gint buffers;

  /* preallocation details */
  glong typemetasize, metasize, datasize;

  /* main chunk of buffers */
  GMemChunk *chunk;
  gint size,used;

  /* auxilliary, used to effect a slow resize */
  GMemChunk *newchunk;
  gint newsize,newused;

  /* linked list of extra buffers, in case of overflow */
  GSList *extra;
};

struct _StreamBufferChunk {
  GMemChunk *chunk;
  gint size,used;
};

void _StreamBufferPool_init();

StreamBufferPool *StreamBufferPool_create(gint buffers,glong typemetasize,
                                          glong metasize,glong datasize);
void StreamBufferPool_resize(StreamBufferPool *pool, gint newsize);
gboolean StreamBufferPool_isresizing(StreamBufferPool *pool);
gint StreamBufferPool_getsize(StreamBufferPool *pool);
gint StreamBufferPool_getbufcount(StreamBufferPool *pool);
void StreamBufferPool_autoresize(StreamBufferPool *pool);

#endif /* STREAMER_BUFFERPOOL_H */
